#ifdef __cplusplus
extern "C" {
#endif
#include <Python.h>
#include <orb/orbit.h>

typedef struct {
	PyObject_HEAD
	CORBA_Object obj;
	CORBA_Environment ev;
	GSList *last_method;
	char *repo_id;
} CORBA_PyObject;


typedef struct {
	PyObject_HEAD
	CORBA_ORB obj;
	CORBA_Environment ev;
	char *last;
} CORBA_ORB_PyObject;


typedef struct {
   PyObject_HEAD
   CORBA_TypeCode tc;	
	char *repo_id;
} CORBA_TypeCode_PyObject;


typedef struct {
   PyObject_HEAD
	PyObject *value, *tc_object;
} CORBA_any_PyObject;


typedef struct {
   PyObject_HEAD
   CORBA_Object obj;
} CORBA_fixed_PyObject;


typedef struct {
	PyObject_HEAD
	PortableServer_POA obj;
	CORBA_Environment ev;
} POA_PyObject;


typedef struct {
	PyObject_HEAD
	PortableServer_POAManager obj;
	CORBA_Environment ev;
} POAManager_PyObject;


typedef struct _ORBitPython_FunctionStruct 
{
	char *orbit_python_version;
	
	PyTypeObject *obj_type;
	CORBA_PyObject *(*obj_new)(CORBA_Object object);
		
	PyTypeObject *orb_type;
	CORBA_ORB_PyObject *(*orb_new)(void);
} _ORBitPython_FunctionStruct;
	
#ifdef INSIDE_PYORBIT
extern PyTypeObject CORBA_PyObject_Type;
extern PyTypeObject CORBA_ORB_PyObject_Type;
extern PyTypeObject CORBA_TypeCode_PyObject_Type;
extern PyTypeObject CORBA_any_PyObject_Type;
extern PyTypeObject CORBA_fixed_PyObject_Type;
extern PyTypeObject POAManager_PyObject_Type;
extern PyTypeObject POA_PyObject_Type;

#define CORBA_PyObject_Check(v) ((v)->ob_type == &CORBA_PyObject_Type)
#define CORBA_ORB_PyObject_Check(v) ((v)->ob_type == &CORBA_ORB_PyObject_Type)
#define CORBA_TypeCode_PyObject_Check(v) \
		((v)->ob_type == &CORBA_TypeCode_PyObject_Type)
#define CORBA_any_PyObject_Check(v) \
		((v)->ob_type == &CORBA_any_PyObject_Type)
#define CORBA_fixed_PyObject_Check(v) \
		((v)->ob_type == &CORBA_fixed_PyObject_Type)
#define POA_PyObject_Check(v) ((v)->ob_type == &POA_PyObject_Type)
#define POAManager_PyObject_Check(v) ((v)->ob_type == &POAManager_PyObject_Type)

#else
struct _ORBitPython_FunctionStruct *_ORBitPython_API;
	
#define PyOrb_Object_New   (_ORBitPython_API->obj_new)
#define PyOrb_ORB_New      (_ORBitPython_API->orb_new)

#define PyOrb_Object_Check(v)  ((v)->ob_type == _ORBitPython_API->obj_type)
#define PyOrb_ORB_Check(v)     ((v)->ob_type == _ORBitPython_API->orb_type)

#define PyOrb_Object_Type  *(_ORBitPython_API->obj_type)
#define PyOrb_ORB_Type     *(_ORBitPython_API->orb_type)
	
#define init_orbit_python() \
{ \
	PyObject *orbpy = PyImport_ImportModule("CORBA"); \
	if (orbpy != NULL) { \
		PyObject *module_dict = PyModule_GetDict(orbpy); \
		PyObject *cobj = PyDict_GetItemString(module_dict, "_ORBitPython_API"); \
		if (PyCObject_Check(cobj)) \
			_ORBitPython_API = PyCObject_AsVoidPtr(cobj); \
		else \
			Py_FatalError("Could not find _ORBitPython_API object"); \
	} else \
		Py_FatalError("Could not import CORBA"); \
}
#endif /* INSIDE_PYORBIT */

#ifdef __cplusplus
}
#endif

/* Local Variables: */
/* c-file-style: "python" */
/* End: */
